/* -*- c++ -*-
 *
 * statspagegnutella.cpp
 *
 * Copyright (C) 2003 Sebastian Sauer <mail@dipe.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 */

#include <qlabel.h>
#include <qvbox.h>

#include <kdebug.h>
#include <klocale.h>
#include <ktextbrowser.h>

#include "kmldonkey.h"
#include "donkeyprotocol.h"
#include "prefs.h"

#include "statspagegnutella.h"
#include "statspagegnutella.moc"

void StatsPageGnutellaCallback::callback(const QString& /*cmd*/, const QString& res)
{
    browser->clear();
    QStringList list = QStringList::split("\n", res);
    for (QStringList::Iterator it = list.begin(); it != list.end(); ++it) {
        browser->append( *it );
    }
}

StatsPageGnutella::StatsPageGnutella(QWidget *parent) : QScrollView(parent)
{
    setResizePolicy(QScrollView::AutoOneFit);
    viewport()->setBackgroundMode(PaletteBackground);

    box = new QVBox();
    box->setSpacing(6);
    box->setMargin(11);
    addChild(box);

    browser = new KTextBrowser(box);
    browser->setTextFormat(QTextBrowser::RichText);

    callback = 0;
}

void StatsPageGnutella::slotUpdate()
{
    if (! KMLDonkey::App->donkey->isConnected()) return;
    if (! callback) {
        callback = new StatsPageGnutellaCallback;
        callback->browser = browser;
    }
    KMLDonkey::App->donkey->sendConsoleMessage("gstats", callback);
}

void StatsPageGnutella::showEvent(QShowEvent* /*event*/)
{
    slotUpdate();
}
